(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('rxjs/Observable'), require('rxjs/add/operator/debounceTime'), require('lodash'), require('rxjs/Subscription'), require('@angular/common'), require('ngx-bootstrap/dropdown')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', 'rxjs/Observable', 'rxjs/add/operator/debounceTime', 'lodash', 'rxjs/Subscription', '@angular/common', 'ngx-bootstrap/dropdown'], factory) :
	(factory((global.ng2 = global.ng2 || {}, global.ng2.list = global.ng2.list || {}, global.ng2.list.view = global.ng2.list.view || {}),global.ng.core,global.ng.forms,global.rxjs_Observable,null,global._,global.rxjs_Subscription,global.ng.common,global.ngxBootstrap_dropdown));
}(this, (function (exports,_angular_core,_angular_forms,rxjs_Observable,rxjs_add_operator_debounceTime,_,rxjs_Subscription,_angular_common,ngxBootstrap_dropdown) { 'use strict';

var ClearFiltersComponent = /** @class */ (function () {
    function ClearFiltersComponent() {
    }
    ClearFiltersComponent.prototype.clear = function () {
        this.clearFiltersEmitter.emit(true);
    };
    ClearFiltersComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: "c-clear-filters",
                    template: '<ng-content></ng-content> '
                },] },
    ];
    /** @nocollapse */
    ClearFiltersComponent.ctorParameters = function () { return []; };
    ClearFiltersComponent.propDecorators = {
        "clearFiltersEmitter": [{ type: _angular_core.Input },],
    };
    return ClearFiltersComponent;
}());

var CounterComponent = /** @class */ (function () {
    function CounterComponent() {
        this.start = 1;
        this.end = 1;
        this.total = 0;
        this.label = "";
        this.customTemplate = false;
    }
    CounterComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: "c-counter",
                    template: '<span *ngIf="total > 0 && !customTemplate"> <strong> <span>{{start}}</span> - <span>{{end}}</span> </strong> of <strong>{{total}}</strong> {{label}} </span> <ng-template [ngIf]="customTemplate"> <ng-content></ng-content> </ng-template> '
                },] },
    ];
    /** @nocollapse */
    CounterComponent.ctorParameters = function () { return []; };
    CounterComponent.propDecorators = {
        "start": [{ type: _angular_core.Input },],
        "end": [{ type: _angular_core.Input },],
        "total": [{ type: _angular_core.Input },],
        "label": [{ type: _angular_core.Input },],
        "customTemplate": [{ type: _angular_core.Input },],
    };
    return CounterComponent;
}());

var ListFormResetDirective = /** @class */ (function () {
    function ListFormResetDirective() {
        this.reset = false;
    }
    ListFormResetDirective.decorators = [
        { type: _angular_core.Directive, args: [{
                    selector: "form[listResetForm]"
                },] },
    ];
    /** @nocollapse */
    ListFormResetDirective.ctorParameters = function () { return []; };
    ListFormResetDirective.propDecorators = {
        "reset": [{ type: _angular_core.Input, args: ['promptReset',] },],
        "form": [{ type: _angular_core.Input, args: ['listResetForm',] },],
    };
    return ListFormResetDirective;
}());

var ListPreviewComponent = /** @class */ (function () {
    function ListPreviewComponent() {
        this.hidden = true;
        this.visibleEmitter = new _angular_core.EventEmitter();
        this.dataEmitter = new _angular_core.EventEmitter();
    }
    /**
     * Closes the list preview.
     */
    /**
         * Closes the list preview.
         */
    ListPreviewComponent.prototype.closePreview = /**
         * Closes the list preview.
         */
    function () {
        this.visibleEmitter.emit(true);
        this.hidden = true;
    };
    Object.defineProperty(ListPreviewComponent.prototype, "data", {
        /**
         * Gets the data.
         *
         * @returns {any}
         */
        get: /**
             * Gets the data.
             *
             * @returns {any}
             */
        function () {
            return this._data;
        },
        /**
         * Sets the data.
         *
         * @param data
         */
        set: /**
             * Sets the data.
             *
             * @param data
             */
        function (data) {
            this._data = data;
            this.forms.forEach(function (resetFormDir) {
                resetFormDir.form.resetForm(data);
            });
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Checks whether the user should be prompted to save changes if form is dirty.
     *
     * @returns {boolean}
     */
    /**
         * Checks whether the user should be prompted to save changes if form is dirty.
         *
         * @returns {boolean}
         */
    ListPreviewComponent.prototype.shouldPromptReset = /**
         * Checks whether the user should be prompted to save changes if form is dirty.
         *
         * @returns {boolean}
         */
    function () {
        var resets = this.forms.map(function (resetFormDir) {
            return resetFormDir.reset && resetFormDir.form.dirty;
        });
        return resets.indexOf(true) !== -1;
    };
    ListPreviewComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: "c-list-preview",
                    template: '<ng-content></ng-content> '
                },] },
    ];
    /** @nocollapse */
    ListPreviewComponent.ctorParameters = function () { return []; };
    ListPreviewComponent.propDecorators = {
        "hidden": [{ type: _angular_core.HostBinding, args: ["class.hidden",] },],
        "visibleEmitter": [{ type: _angular_core.Input },],
        "dataEmitter": [{ type: _angular_core.Input },],
        "forms": [{ type: _angular_core.ContentChildren, args: [ListFormResetDirective,] },],
    };
    return ListPreviewComponent;
}());

/**
 * @deprecated Use list view directly.
 */
var ListRowComponent = /** @class */ (function () {
    function ListRowComponent() {
        this.previewHidden = true;
        this.visibleEmitter = new _angular_core.EventEmitter();
        this.dataEmitter = new _angular_core.EventEmitter();
    }
    ListRowComponent.prototype.togglePreviewVisibility = function () {
        this.previewHidden = !this.previewHidden;
        this.visibleEmitter.emit(this.previewHidden);
    };
    ListRowComponent.prototype.setActiveRow = function (row, event) {
        if (event) {
            event.stopPropagation();
            event.preventDefault();
        }
        if (!this.isActiveRow(row)) {
            this.activeRow = row;
            this.dataEmitter.emit(row);
            if (this.isPreviewHidden()) {
                this.togglePreviewVisibility();
            }
        }
        else {
            this.togglePreviewVisibility();
        }
    };
    ListRowComponent.prototype.isActiveRow = function (row) {
        return this.activeRow === row && !this.isPreviewHidden();
    };
    ListRowComponent.prototype.isPreviewHidden = function () {
        return this.previewHidden;
    };
    ListRowComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: "c-list-row",
                    template: '<ng-content></ng-content> '
                },] },
    ];
    /** @nocollapse */
    ListRowComponent.ctorParameters = function () { return []; };
    ListRowComponent.propDecorators = {
        "previewHidden": [{ type: _angular_core.Input },],
        "visibleEmitter": [{ type: _angular_core.Input },],
        "dataEmitter": [{ type: _angular_core.Input },],
    };
    return ListRowComponent;
}());

var PaginationComponent = /** @class */ (function () {
    function PaginationComponent() {
        this.type = 'buttons';
        this.page = 1;
        this.pageCount = 1;
        this.pages = [];
        this.updating = false;
    }
    PaginationComponent.prototype.ngOnChanges = function (changes) {
        this.pages = this.updatePagination();
    };
    PaginationComponent.prototype.onPrev = function () {
        this.goToPage(this.page - 1);
    };
    PaginationComponent.prototype.onNext = function () {
        this.goToPage(this.page + 1);
    };
    PaginationComponent.prototype.goToPage = function (page) {
        this.updating = true;
        this.changePageEmitter.emit(page);
    };
    PaginationComponent.prototype.updatePagination = function () {
        this.updating = false;
        var pagesArray = [];
        var currentPage = this.page;
        var pagesCount = this.pageCount;
        if (this.type === 'buttons') {
            var paginationSpan = 2;
            var startPos = 2;
            var endPos = startPos + paginationSpan - 1;
            var middlePos = Math.ceil(paginationSpan / 2);
            // Adjust start and end positions to maintain range and keep current page as active.
            if (currentPage >= startPos + 1) {
                startPos = currentPage - middlePos + 1;
                endPos = startPos + paginationSpan - 1;
                if (endPos + 1 > pagesCount) {
                    startPos = pagesCount - paginationSpan;
                    endPos = pagesCount - 1;
                }
            }
            /*
                         * Extra adjustments in case pagination range is larger than results.
                         */
            if (startPos < 2) {
                startPos = 2;
            }
            if (endPos >= pagesCount) {
                endPos = pagesCount - 1;
            }
            if (endPos < startPos) {
                endPos = startPos - 1;
            }
            // Only show pagination when there is more than one page.
            if (pagesCount > 1) {
                /*
                                 * Create pagination range.
                                 */
                pagesArray.push({
                    value: 1,
                    isPage: true,
                    active: +currentPage === 1,
                    disabled: false
                });
                if (startPos > 2) {
                    pagesArray.push({ value: "...", isPage: false, active: false, disabled: true });
                }
                for (var i = startPos; i <= endPos; i++) {
                    pagesArray.push({
                        value: i,
                        isPage: true,
                        active: i === +currentPage,
                        disabled: false
                    });
                }
                if (endPos + 1 !== +pagesCount) {
                    pagesArray.push({ value: "...", isPage: false, active: false, disabled: true });
                }
                pagesArray.push({
                    value: pagesCount,
                    isPage: true,
                    active: +pagesCount === +currentPage,
                    disabled: false
                });
            }
        }
        else {
            for (var i = 1; i <= this.pageCount; i++) {
                pagesArray.push(i);
            }
        }
        return pagesArray;
    };
    PaginationComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: "c-pagination",
                    template: '<ng-template [ngIf]="type === \'buttons\'"> <nav *ngIf="pages.length > 1"> <div class="btn-group m-r-sm"> <button type="button" class="btn btn-white" (click)="onPrev()"> <i class="fa fa-chevron-left"></i> </button> <button *ngFor="let page of pages" class="btn btn-white" [ngClass]="{active: page.active}" (click)="goToPage(page.value)"> {{page.value}} </button> <button type="button" class="btn btn-white" (click)="onNext()"> <i class="fa fa-chevron-right"></i> </button> </div> </nav> </ng-template> <ng-template [ngIf]="type !== \'buttons\' && pages.length > 1"> <ng-content></ng-content> <select [(ngModel)]="page" (ngModelChange)="goToPage($event)"> <option *ngFor="let current of pages" [value]="current">{{current}}</option> </select> </ng-template> '
                },] },
    ];
    /** @nocollapse */
    PaginationComponent.ctorParameters = function () { return []; };
    PaginationComponent.propDecorators = {
        "type": [{ type: _angular_core.Input },],
        "page": [{ type: _angular_core.Input },],
        "pageCount": [{ type: _angular_core.Input },],
        "changePageEmitter": [{ type: _angular_core.Input },],
    };
    return PaginationComponent;
}());

var SearchComponent = /** @class */ (function () {
    function SearchComponent() {
        this.searchTerm = new _angular_core.EventEmitter();
        this.placeholder = "Search";
        this.debounceTime = 500;
        this.isCustom = false;
        this.classes = ["form-control"];
        this.searchInputControl = new _angular_forms.FormControl();
    }
    SearchComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Subscribe to and debounce form control, emitting search results
        this.searchInputControl
            .valueChanges
            .debounceTime(this.debounceTime)
            .subscribe(function (term) {
            _this.searchInputControl.setValue(term, { emitEvent: false });
            if (_this.target) {
                _this.target.searchTerm.emit(term);
            }
            else {
                _this.searchTerm.emit(term);
            }
        });
    };
    SearchComponent.prototype.clearSearchTerm = function (emit) {
        if (emit === void 0) { emit = false; }
        this.searchInputControl.setValue("", { emitEvent: emit });
    };
    SearchComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: "c-search",
                    template: '<ng-template [ngIf]="isCustom"> <ng-content></ng-content> </ng-template> <ng-template [ngIf]="!isCustom"> <div class="form-group"> <a (click)="clearSearchTerm(true)" class="search-clear"> <i class="fa fa-times fa-1x"></i> </a> <input type="text" [ngClass]="classes" placeholder="Search" [formControl]="searchInputControl" /> </div> </ng-template> ',
                    styles: ["\n        :host {\n            position: relative;\n            display: block;\n        }\n        .search-clear {\n            position: absolute;\n            top: 7px;\n            right: 8px;\n        }\n        a {\n            cursor: pointer;\n        }\n    "]
                },] },
    ];
    /** @nocollapse */
    SearchComponent.ctorParameters = function () { return []; };
    SearchComponent.propDecorators = {
        "searchTerm": [{ type: _angular_core.Output }, { type: _angular_core.Input },],
        "placeholder": [{ type: _angular_core.Input },],
        "debounceTime": [{ type: _angular_core.Input },],
        "isCustom": [{ type: _angular_core.Input },],
        "target": [{ type: _angular_core.Input },],
    };
    return SearchComponent;
}());

var NotFoundComponent = /** @class */ (function () {
    function NotFoundComponent() {
        this.classes = "alert alert-warning text-center";
        this.show = false;
    }
    NotFoundComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: "c-not-found",
                    template: '<div *ngIf="show" [ngClass]="classes"> <ng-content></ng-content> </div>'
                },] },
    ];
    /** @nocollapse */
    NotFoundComponent.ctorParameters = function () { return []; };
    NotFoundComponent.propDecorators = {
        "classes": [{ type: _angular_core.Input },],
        "show": [{ type: _angular_core.Input },],
    };
    return NotFoundComponent;
}());

var NoResultsComponent = /** @class */ (function () {
    function NoResultsComponent() {
        this.classes = "alert alert-warning text-center";
        this.show = false;
    }
    NoResultsComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: "c-no-results",
                    template: '<div *ngIf="show" [ngClass]="classes"> <ng-content></ng-content> </div> '
                },] },
    ];
    /** @nocollapse */
    NoResultsComponent.ctorParameters = function () { return []; };
    NoResultsComponent.propDecorators = {
        "classes": [{ type: _angular_core.Input },],
        "show": [{ type: _angular_core.Input },],
    };
    return NoResultsComponent;
}());

var ShowMoreComponent = /** @class */ (function () {
    function ShowMoreComponent() {
        this.moreResults = false;
        this.loadMoreEmitter = new _angular_core.EventEmitter();
    }
    ShowMoreComponent.prototype.loadMore = function () {
        this.loadMoreEmitter.emit(true);
    };
    ShowMoreComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: "c-show-more",
                    template: '<div *ngIf="moreResults" class="text-center m-t-md clearfix"> <button (click)="loadMore()" class="btn-grey btn">Show more</button> </div> '
                },] },
    ];
    /** @nocollapse */
    ShowMoreComponent.ctorParameters = function () { return []; };
    ShowMoreComponent.propDecorators = {
        "loadMoreEmitter": [{ type: _angular_core.Input },],
    };
    return ShowMoreComponent;
}());

var ICheckDirective = /** @class */ (function () {
    function ICheckDirective(element, renderer) {
        this.element = element;
        this.renderer = renderer;
        this.icheckChange = new _angular_core.EventEmitter();
        this.type = "checkbox";
    }
    /**
     * @inheritDoc
     */
    /**
       * @inheritDoc
       */
    ICheckDirective.prototype.ngOnInit = /**
       * @inheritDoc
       */
    function () {
        var _this = this;
        this.parentElement = this.renderer.createElement('div');
        var currentParent = this.renderer.parentNode(this.element.nativeElement);
        this.renderer.insertBefore(currentParent, this.parentElement, this.element.nativeElement);
        this.renderer.addClass(this.parentElement, 'icheckbox_square-blue');
        this.renderer.setStyle(this.parentElement, 'position', 'relative');
        this.renderer.setStyle(this.element.nativeElement, 'display', 'none');
        this.renderer.listen(this.parentElement, 'click', function (event) { return _this.toggleCheckbox(event); });
    };
    /**
     * Toggles the checkbox.
     *
     * @param event
    */
    /**
       * Toggles the checkbox.
       *
       * @param event
      */
    ICheckDirective.prototype.toggleCheckbox = /**
       * Toggles the checkbox.
       *
       * @param event
      */
    function (event) {
        event.preventDefault();
        this.isChecked = !this.isChecked;
        this.updateCheckStatus();
    };
    /**
     * @inheritdoc
     */
    /**
       * @inheritdoc
       */
    ICheckDirective.prototype.ngOnChanges = /**
       * @inheritdoc
       */
    function (changes) {
        this.isChecked = this.isChecked || false;
        this.updateCheckStatus(false);
    };
    /**
     * Updates the value
     */
    /**
       * Updates the value
       */
    ICheckDirective.prototype.updateCheckStatus = /**
       * Updates the value
       */
    function (emit) {
        if (emit === void 0) { emit = true; }
        if (this.isChecked) {
            this.renderer.addClass(this.parentElement, 'checked');
        }
        else if (this.parentElement) {
            this.renderer.removeClass(this.parentElement, 'checked');
        }
        if (emit) {
            this.icheckChange.emit(+this.isChecked);
        }
    };
    ICheckDirective.prototype.check = function () {
        this.isChecked = true;
        this.updateCheckStatus();
    };
    ICheckDirective.prototype.unCheck = function () {
        this.isChecked = false;
        this.updateCheckStatus();
    };
    ICheckDirective.decorators = [
        { type: _angular_core.Directive, args: [{
                    selector: "input[icheck]"
                },] },
    ];
    /** @nocollapse */
    ICheckDirective.ctorParameters = function () { return [
        { type: _angular_core.ElementRef, },
        { type: _angular_core.Renderer2, },
    ]; };
    ICheckDirective.propDecorators = {
        "isChecked": [{ type: _angular_core.Input, args: ["icheck",] },],
        "icheckChange": [{ type: _angular_core.Output },],
        "type": [{ type: _angular_core.Input },],
        "value": [{ type: _angular_core.Input },],
    };
    return ICheckDirective;
}());

var ListFilterComponent = /** @class */ (function () {
    function ListFilterComponent() {
        this.title = "";
        this.name = "";
        this.items = [];
        this.displayName = "label";
        this.value = "value";
        this.checkedItems = {};
        this.itemsActive = 0;
        this.menuShown = false;
    }
    ListFilterComponent.prototype.ngOnInit = function () {
        var _this = this;
        // If data is specified and items is empty fetch and fill.
        if (this.dataService) {
            this.dataService
                .fetchAll()
                .subscribe(function (data) {
                _this.items = data.payload;
            });
        }
    };
    ListFilterComponent.prototype.reset = function () {
        this.itemsActive = 0;
        this.checkedItems = {};
        this.checkboxes.forEach(function (item) {
            item.unCheck();
        });
    };
    /**
     * When a filter is made active or deactivated.
     *
     * @param name The name of the item.
     * @param event The filter returned.
     */
    /**
         * When a filter is made active or deactivated.
         *
         * @param name The name of the item.
         * @param event The filter returned.
         */
    ListFilterComponent.prototype.rowChecked = /**
         * When a filter is made active or deactivated.
         *
         * @param name The name of the item.
         * @param event The filter returned.
         */
    function (name, event) {
        var _this = this;
        this.checkedItems[name] = event;
        clearTimeout(this.timeout);
        this.timeout = setTimeout(function () {
            var value = Object.keys(_.pickBy(_this.checkedItems, function (value, key) {
                return value;
            }));
            _this.filterEmitter.emit({
                name: _this.name,
                value: value,
                operator: "IN"
            });
            _this.itemsActive = value.length;
        }, 1000);
    };
    ListFilterComponent.prototype.toggleClickMenu = function (e) {
        e.stopPropagation();
        e.preventDefault();
        this.menuShown = !this.menuShown;
    };
    ListFilterComponent.prototype.closeMenu = function (e) {
        this.menuShown = false;
    };
    ListFilterComponent.prototype.showDropDown = function () {
        return this.menuShown ? "block" : "hide";
    };
    ListFilterComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: "c-list-filter",
                    template: '<span dropdown> <button type="button" class="btn btn-default dropdown-toggle" dropdownToggle> <span>{{title}}</span> <span *ngIf="itemsActive > 0"> ({{itemsActive}}) </span> <span class="caret"></span> </button> <ul class="dropdown-menu" *dropdownMenu> <li *ngFor="let item of items"> <a> <label> <input type="checkbox" [icheck]="false" (icheckChange)="rowChecked(item[value], $event)" /> {{item[displayName]}} </label> </a> </li> </ul> </span> '
                },] },
    ];
    /** @nocollapse */
    ListFilterComponent.ctorParameters = function () { return []; };
    ListFilterComponent.propDecorators = {
        "title": [{ type: _angular_core.Input },],
        "name": [{ type: _angular_core.Input },],
        "items": [{ type: _angular_core.Input },],
        "displayName": [{ type: _angular_core.Input },],
        "value": [{ type: _angular_core.Input },],
        "dataService": [{ type: _angular_core.Input },],
        "checkedItems": [{ type: _angular_core.Input },],
        "filterEmitter": [{ type: _angular_core.Input },],
        "checkboxes": [{ type: _angular_core.ViewChildren, args: [ICheckDirective,] },],
    };
    return ListFilterComponent;
}());

var DateFilterComponent = /** @class */ (function () {
    function DateFilterComponent() {
        this.value = "";
    }
    DateFilterComponent.prototype.changeValue = function (value) {
        this.value = value;
        this.filterEmitter.emit({
            name: this.name,
            value: value,
            operator: "="
        });
    };
    DateFilterComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: "c-date-filter",
                    template: ' <label>{{title}}</label> <input type="date" class="form-control" style="width:155px;display:inline-block" [ngModel]="value" (ngModelChange)="changeValue($event)" /> '
                },] },
    ];
    /** @nocollapse */
    DateFilterComponent.ctorParameters = function () { return []; };
    DateFilterComponent.propDecorators = {
        "title": [{ type: _angular_core.Input },],
        "name": [{ type: _angular_core.Input },],
        "filterEmitter": [{ type: _angular_core.Input },],
    };
    return DateFilterComponent;
}());

/**
 * This component is a container for managing list view components together.
 * Its purpose is to manage and disperse data from a single location making management easier.
 *
 * Basic Example Usage
 * -------------
 *
 * Component TS
 *
 * @Component({
 *    selector: 'c-my-component',
 *    template: `
 *        <c-list-view #list [dataService]="userService">
 *          <c-pagination></c-pagination>
 *          <div *ngFor="let row of list.rows">
 *            {{row.firstName}}
 *          </div>
 *        </c-list-view>
 *    `,
 *
 * })
 * class MyComponent {
 *     constructor(public userService: UserService) {}
 * }
 *
 */
var ListViewComponent = /** @class */ (function () {
    function ListViewComponent() {
        this.changePageEmitter = new _angular_core.EventEmitter();
        this.searchTerm = new _angular_core.EventEmitter();
        this.filtersEmitter = new _angular_core.EventEmitter();
        this.filterEmitter = new _angular_core.EventEmitter();
        this.clearFiltersEmitter = new _angular_core.EventEmitter();
        this.listPreviewVisibleEmitter = new _angular_core.EventEmitter();
        this.activeRowEmitter = new _angular_core.EventEmitter();
        this.loadMoreEmitter = new _angular_core.EventEmitter();
        this.pageChangeScrollTop = false;
        this.handleRequestErrorEmitter = new _angular_core.EventEmitter();
        this.filters = [];
        this.currentPage = 1;
        this.loading = true;
        this.meta = {};
        this.rows = [];
        this.previewHidden = true;
        this.originalFilters = [];
        this.lastSearch = "";
        this.updating = false;
    }
    /**
     * @inheritdoc
     */
    /**
         * @inheritdoc
         */
    ListViewComponent.prototype.ngOnInit = /**
         * @inheritdoc
         */
    function () {
        var _this = this;
        this.filters = this.dataService.getFilters();
        // Fetch original filters for reset.
        this.originalFilters = JSON.parse(JSON.stringify(this.filters));
        this.dataSource = this.dataService.setParam("filters", this.filters).fetchAll();
        // Subscription to page change triggered by `pagination` component
        this.changePageEmitter.subscribe(function (page) {
            _this.updating = true;
            _this.dataSource = _this.dataService.setParam("page", page).fetchAll();
            _this.updateSubscriptions().then(function () {
                if (_this.pageChangeScrollTop) {
                    document.body.scrollTop = 0;
                }
            });
        });
        // Subscription to search term change triggered by `search` component
        this.searchTerm.subscribe(function (term) {
            // Record last search
            // Record last search
            _this.lastSearch = term;
            // Reset pagination back to first page
            // Reset pagination back to first page
            _this.dataService.setParam("page", 1);
            // Add search term to filters array
            // Add search term to filters array
            _this.applyUniqueFilter({
                name: "searchField",
                value: term,
                operator: "="
            });
            // Reapply filters
            // Reapply filters
            _this.applyFilters();
        });
        // An event to change all filters.
        this.filtersEmitter.subscribe(function (filters) {
            // Set all emitter filters to filter array
            // Set all emitter filters to filter array
            _this.filters = filters;
            // Reapply filters
            // Reapply filters
            _this.applyFilters();
        });
        this.filterEmitter.subscribe(function (filter) {
            // Push emitted filter to filter array
            // Push emitted filter to filter array
            _this.applyUniqueFilter(filter);
            // Reapply filters
            // Reapply filters
            _this.applyFilters();
        });
        // An event to clear all filters.
        this.clearFiltersEmitter.subscribe(function (clear) {
            _this.clearFilters(clear);
        });
        this.listPreviewVisibleEmitter.subscribe(function (hidden) {
            _this.listPreviewComponent.hidden = hidden;
            if (_this.listRowComponent) {
                _this.listRowComponent.previewHidden = hidden;
            }
            _this.previewHidden = hidden;
        });
        this.activeRowEmitter.subscribe(function (row) {
            _this.activeID = row[_this.dataService.primaryKey()];
            _this.listPreviewComponent.data = row;
        });
        this.loadMoreEmitter.subscribe(function () {
            if (_this.currentPage !== _this.pageCount) {
                _this.dataService.setParam("page", ++_this.currentPage);
                _this.applyFilters(true);
            }
        });
    };
    /**
     * Resets the page index back to zero.
     *
     * @param withRefresh whether to refresh or wait.
     */
    /**
         * Resets the page index back to zero.
         *
         * @param withRefresh whether to refresh or wait.
         */
    ListViewComponent.prototype.resetPageIndex = /**
         * Resets the page index back to zero.
         *
         * @param withRefresh whether to refresh or wait.
         */
    function (withRefresh) {
        if (withRefresh === void 0) { withRefresh = false; }
        this.currentPage = 1;
        this.dataService.setParam("page", 1);
        if (withRefresh) {
            this.refresh();
        }
    };
    /**
     * @inheritdoc
     */
    /**
         * @inheritdoc
         */
    ListViewComponent.prototype.ngAfterContentInit = /**
         * @inheritdoc
         */
    function () {
        // Sync data to child components
        this.updateSubscriptions();
    };
    /**
     * Refreshes the list.
     */
    /**
         * Refreshes the list.
         */
    ListViewComponent.prototype.refresh = /**
         * Refreshes the list.
         */
    function (hidePreview) {
        if (hidePreview === void 0) { hidePreview = true; }
        this.updating = true;
        return this.updateSubscriptions(false, hidePreview);
    };
    /**
     * Changes all filters.
     *
     * @param filters
     */
    /**
         * Changes all filters.
         *
         * @param filters
         */
    ListViewComponent.prototype.replaceFilters = /**
         * Changes all filters.
         *
         * @param filters
         */
    function (filters) {
        this.filters = filters;
        this.applyFilters();
    };
    /**
     * Resets the data source back to default with filters if defined.
     *
     * @param {Array<ApiFilterInterface>} filters
     */
    /**
         * Resets the data source back to default with filters if defined.
         *
         * @param {Array<ApiFilterInterface>} filters
         */
    ListViewComponent.prototype.resetDataSource = /**
         * Resets the data source back to default with filters if defined.
         *
         * @param {Array<ApiFilterInterface>} filters
         */
    function (filters) {
        if (filters === void 0) { filters = null; }
        if (filters !== null) {
            this.originalFilters = filters;
        }
        this.clearFilters(true);
    };
    /**
     * Makes sure that filter is unique. Updates existing if already exists.
     *
     * @param filter
     */
    /**
         * Makes sure that filter is unique. Updates existing if already exists.
         *
         * @param filter
         */
    ListViewComponent.prototype.applyUniqueFilter = /**
         * Makes sure that filter is unique. Updates existing if already exists.
         *
         * @param filter
         */
    function (filter) {
        var item = this.filters.findIndex(function (item) { return item.name === filter.name; });
        if (item === -1) {
            this.filters.push(filter);
        }
        else {
            this.filters[item] = filter;
        }
    };
    /**
     * Applys filters and update subscriptions.
     */
    /**
         * Applys filters and update subscriptions.
         */
    ListViewComponent.prototype.applyFilters = /**
         * Applys filters and update subscriptions.
         */
    function (append) {
        if (append === void 0) { append = false; }
        // Apply filters to data service
        this.updating = true;
        this.dataSource = this.dataService
            .setParam("page", 1)
            .setParam("filters", this.filters)
            .fetchAll();
        this.updateSubscriptions(append);
    };
    /**
     * Clears all filters stored against this list view.
     *
     * @param clear
     */
    /**
         * Clears all filters stored against this list view.
         *
         * @param clear
         */
    ListViewComponent.prototype.clearFilters = /**
         * Clears all filters stored against this list view.
         *
         * @param clear
         */
    function (clear) {
        this.currentPage = 1;
        this.dataService.setParam("page", this.currentPage);
        // Clear filters here (on the parent)
        this.filters = clear ? JSON.parse(JSON.stringify(this.originalFilters)) : this.filters;
        // Clear filters for `search` component
        if (this.searchComponent) {
            this.searchComponent.clearSearchTerm();
        }
        if (this.listFiltersComponent) {
            this.listFiltersComponent.forEach(function (component) { return component.reset(); });
        }
        // Reapply filters
        this.applyFilters();
    };
    /**
     * Syncs all data to child components
     */
    /**
         * Syncs all data to child components
         */
    ListViewComponent.prototype.updateSubscriptions = /**
         * Syncs all data to child components
         */
    function (append, hidePreview) {
        var _this = this;
        if (append === void 0) { append = false; }
        if (hidePreview === void 0) { hidePreview = true; }
        return new Promise(function (resolve, reject) {
            if (_this.contentHandle) {
                _this.contentHandle.unsubscribe();
            }
            _this.contentHandle = _this.dataSource.subscribe(function (data) {
                _this.loading = false;
                _this.updating = false;
                _this.meta = data.meta;
                if (append) {
                    _this.rows = _this.rows.concat(data.payload);
                }
                else {
                    _this.rows = data.payload;
                }
                _this.currentPage = data.meta.page;
                _this.pageCount = data.meta.pageCount;
                _this.initSearchComponent();
                _this.initListRowComponent(data, append);
                _this.initPaginationComponent(data);
                _this.initCounterComponent(data);
                _this.initNotFoundComponent(data);
                _this.initNoResultsComponent(data);
                _this.initClearFiltersComponent();
                _this.initListFiltersComponent();
                _this.initDateFiltersComponent();
                _this.initListPreviewComponent(hidePreview);
                _this.initShowMoreComponent(data);
                resolve(true);
            }, function (error) {
                _this.handleRequestErrorEmitter.emit(error);
                reject(error);
            });
        });
    };
    /**
     * Initiates SearchComponent sub component.
     */
    /**
         * Initiates SearchComponent sub component.
         */
    ListViewComponent.prototype.initSearchComponent = /**
         * Initiates SearchComponent sub component.
         */
    function () {
        // Data for `search` component
        if (this.searchComponent) {
            if (this.searchComponent.target === this || this.searchComponent.target === undefined) {
                this.searchComponent.searchTerm = this.searchTerm;
            }
        }
    };
    /**
     * Initiates ListRowComponent sub component.
     */
    /**
         * Initiates ListRowComponent sub component.
         */
    ListViewComponent.prototype.initListRowComponent = /**
         * Initiates ListRowComponent sub component.
         */
    function (data, append) {
        if (append === void 0) { append = false; }
        // Data for `list-row` component
        if (this.listRowComponent) {
            this.listRowComponent.visibleEmitter = this.listPreviewVisibleEmitter;
            this.listRowComponent.dataEmitter = this.activeRowEmitter;
            if (append) {
                this.listRowComponent.rows = this.listRowComponent.rows.concat(data.payload);
            }
            else {
                this.listRowComponent.rows = data.payload;
            }
        }
    };
    /**
     * Initiates PaginationComponent sub component.
     */
    /**
         * Initiates PaginationComponent sub component.
         */
    ListViewComponent.prototype.initPaginationComponent = /**
         * Initiates PaginationComponent sub component.
         */
    function (data) {
        var _this = this;
        var page = parseInt(data.meta.page);
        var pageCount = parseInt(data.meta.pageCount);
        // Data for `pagination` component
        if (this.paginationComponent) {
            this.paginationComponent.forEach(function (component) {
                component.changePageEmitter = _this.changePageEmitter;
                component.page = page;
                component.pageCount = pageCount;
                component.pages = component.updatePagination();
            });
        }
    };
    /**
     * Initiates CounterComponent sub component.
     */
    /**
         * Initiates CounterComponent sub component.
         */
    ListViewComponent.prototype.initCounterComponent = /**
         * Initiates CounterComponent sub component.
         */
    function (data) {
        var page = parseInt(data.meta.page);
        var perPage = parseInt(data.meta.perPage);
        var totalCount = parseInt(data.meta.totalCount);
        var start = page * perPage - perPage + 1;
        var end = page * perPage;
        // Data for `counter` component
        if (this.counterComponents) {
            this.counterComponents.forEach(function (component) {
                component.start = start;
                component.end = end > totalCount ? totalCount : end;
                component.total = totalCount;
            });
        }
    };
    /**
     * Checks if the current list has been filtered in any way.
     * @returns {boolean}
     */
    /**
         * Checks if the current list has been filtered in any way.
         * @returns {boolean}
         */
    ListViewComponent.prototype.isFiltered = /**
         * Checks if the current list has been filtered in any way.
         * @returns {boolean}
         */
    function () {
        var noFilters = JSON.stringify(this.filters) === JSON.stringify(this.originalFilters);
        return this.lastSearch.length !== 0 || !noFilters;
    };
    /**
     * Initiates NotFoundComponent sub component.
     */
    /**
         * Initiates NotFoundComponent sub component.
         */
    ListViewComponent.prototype.initNotFoundComponent = /**
         * Initiates NotFoundComponent sub component.
         */
    function (data) {
        // Data for `not-found` component
        if (this.notFoundComponent) {
            this.notFoundComponent.show = this.isFiltered() && data.payload.length === 0;
        }
    };
    /**
     * Initiates NoResultsComponent sub component.
     */
    /**
         * Initiates NoResultsComponent sub component.
         */
    ListViewComponent.prototype.initNoResultsComponent = /**
         * Initiates NoResultsComponent sub component.
         */
    function (data) {
        // Data for `no-results` component
        if (this.noResultsComponent) {
            this.noResultsComponent.show = data.payload.length === 0 && !this.isFiltered();
        }
    };
    /**
     * Initiates ClearFiltersComponent sub component.
     */
    /**
         * Initiates ClearFiltersComponent sub component.
         */
    ListViewComponent.prototype.initClearFiltersComponent = /**
         * Initiates ClearFiltersComponent sub component.
         */
    function () {
        var _this = this;
        // Data for `clear-filters` component
        if (this.clearFiltersComponent) {
            this.clearFiltersComponent.forEach(function (component) {
                component.clearFiltersEmitter = _this.clearFiltersEmitter;
            });
        }
    };
    /**
     * Initiates ListFiltersComponent sub component.
     */
    /**
         * Initiates ListFiltersComponent sub component.
         */
    ListViewComponent.prototype.initListFiltersComponent = /**
         * Initiates ListFiltersComponent sub component.
         */
    function () {
        var _this = this;
        if (this.listFiltersComponent) {
            this.listFiltersComponent.forEach(function (component) {
                component.filterEmitter = _this.filterEmitter;
            });
        }
    };
    /**
     * Initiates DateFiltersComponent sub component.
     */
    /**
         * Initiates DateFiltersComponent sub component.
         */
    ListViewComponent.prototype.initDateFiltersComponent = /**
         * Initiates DateFiltersComponent sub component.
         */
    function () {
        var _this = this;
        if (this.dateFiltersComponent) {
            this.dateFiltersComponent.forEach(function (component) {
                component.filterEmitter = _this.filterEmitter;
            });
        }
    };
    /**
     * Initiates ListPreviewComponent sub component.
     */
    /**
         * Initiates ListPreviewComponent sub component.
         */
    ListViewComponent.prototype.initListPreviewComponent = /**
         * Initiates ListPreviewComponent sub component.
         */
    function (hidePreview) {
        var _this = this;
        if (hidePreview === void 0) { hidePreview = true; }
        if (this.listPreviewComponent) {
            this.listPreviewComponent.visibleEmitter = this.listPreviewVisibleEmitter;
            this.listPreviewComponent.dataEmitter = this.activeRowEmitter;
            this.listPreviewVisibleEmitter.emit(hidePreview);
            if (this.activeID && !hidePreview) {
                // For backward compatibility.
                if (this.listRowComponent) {
                    var row = this.listRowComponent.rows.find(function (row) {
                        if (row[_this.dataService.primaryKey()] === _this.activeID) {
                            return true;
                        }
                    });
                    if (row) {
                        this.listRowComponent.setActiveRow(row);
                    }
                }
                var data = this.rows.find(function (row) {
                    if (row[_this.dataService.primaryKey()] === _this.activeID) {
                        return true;
                    }
                });
                if (data) {
                    this.setActiveRow(data);
                }
            }
        }
    };
    /**
     * Initiate Show more sub component.
     *
     * @param data
     */
    /**
         * Initiate Show more sub component.
         *
         * @param data
         */
    ListViewComponent.prototype.initShowMoreComponent = /**
         * Initiate Show more sub component.
         *
         * @param data
         */
    function (data) {
        if (this.showMoreComponent) {
            var page = parseInt(data.meta.page);
            var pageCount = parseInt(data.meta.pageCount);
            var totalCount = parseInt(data.meta.totalCount);
            this.showMoreComponent.loadMoreEmitter = this.loadMoreEmitter;
            this.showMoreComponent.moreResults = page !== pageCount && totalCount !== 0;
        }
    };
    /**
     * Toggles the visibility of the list preview component.
     */
    /**
         * Toggles the visibility of the list preview component.
         */
    ListViewComponent.prototype.togglePreviewVisibility = /**
         * Toggles the visibility of the list preview component.
         */
    function () {
        this.previewHidden = !this.previewHidden;
        this.listPreviewVisibleEmitter.emit(this.previewHidden);
    };
    /**
     * Sets the current row as active.
     *
     * @param row
     * @param {Event} event
     * @return {boolean}
     */
    /**
         * Sets the current row as active.
         *
         * @param row
         * @param {Event} event
         * @return {boolean}
         */
    ListViewComponent.prototype.setActiveRow = /**
         * Sets the current row as active.
         *
         * @param row
         * @param {Event} event
         * @return {boolean}
         */
    function (row, event) {
        if (event) {
            event.stopPropagation();
            event.preventDefault();
        }
        if (this.listPreviewComponent && this.listPreviewComponent.shouldPromptReset()) {
            if (!window.confirm("Your unsaved changes will be reset, continue?")) {
                return false;
            }
        }
        if (!this.isActiveRow(row)) {
            this.activeRow = row;
            this.activeRowEmitter.emit(row);
            if (this.isPreviewHidden()) {
                this.togglePreviewVisibility();
            }
        }
        else {
            this.togglePreviewVisibility();
        }
        return true;
    };
    /**
     * Checks if the current row is the active one.
     *
     * @param row
     * @returns {boolean}
     */
    /**
         * Checks if the current row is the active one.
         *
         * @param row
         * @returns {boolean}
         */
    ListViewComponent.prototype.isActiveRow = /**
         * Checks if the current row is the active one.
         *
         * @param row
         * @returns {boolean}
         */
    function (row) {
        return this.activeRow === row && !this.isPreviewHidden();
    };
    /**
     * Checks if the preview is hidden.
     *
     * @returns {boolean}
     */
    /**
         * Checks if the preview is hidden.
         *
         * @returns {boolean}
         */
    ListViewComponent.prototype.isPreviewHidden = /**
         * Checks if the preview is hidden.
         *
         * @returns {boolean}
         */
    function () {
        return this.previewHidden;
    };
    ListViewComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: "c-list-view",
                    template: '<ng-content></ng-content>',
                },] },
    ];
    /** @nocollapse */
    ListViewComponent.ctorParameters = function () { return []; };
    ListViewComponent.propDecorators = {
        "dataService": [{ type: _angular_core.Input },],
        "changePageEmitter": [{ type: _angular_core.Input },],
        "searchTerm": [{ type: _angular_core.Input },],
        "filtersEmitter": [{ type: _angular_core.Input },],
        "filterEmitter": [{ type: _angular_core.Input },],
        "clearFiltersEmitter": [{ type: _angular_core.Input },],
        "listPreviewVisibleEmitter": [{ type: _angular_core.Input },],
        "activeRowEmitter": [{ type: _angular_core.Input },],
        "loadMoreEmitter": [{ type: _angular_core.Input },],
        "pageChangeScrollTop": [{ type: _angular_core.Input },],
        "handleRequestErrorEmitter": [{ type: _angular_core.Output, args: ["handleRequestError",] },],
        "previewHidden": [{ type: _angular_core.Input },],
        "counterComponents": [{ type: _angular_core.ContentChildren, args: [CounterComponent,] },],
        "searchComponent": [{ type: _angular_core.ContentChild, args: [SearchComponent,] },],
        "listRowComponent": [{ type: _angular_core.ContentChild, args: [ListRowComponent,] },],
        "paginationComponent": [{ type: _angular_core.ContentChildren, args: [PaginationComponent,] },],
        "notFoundComponent": [{ type: _angular_core.ContentChild, args: [NotFoundComponent,] },],
        "noResultsComponent": [{ type: _angular_core.ContentChild, args: [NoResultsComponent,] },],
        "clearFiltersComponent": [{ type: _angular_core.ContentChildren, args: [ClearFiltersComponent,] },],
        "listFiltersComponent": [{ type: _angular_core.ContentChildren, args: [ListFilterComponent,] },],
        "dateFiltersComponent": [{ type: _angular_core.ContentChildren, args: [DateFilterComponent,] },],
        "listPreviewComponent": [{ type: _angular_core.ContentChild, args: [ListPreviewComponent,] },],
        "showMoreComponent": [{ type: _angular_core.ContentChild, args: [ShowMoreComponent,] },],
    };
    return ListViewComponent;
}());

var ListViewModule = /** @class */ (function () {
    function ListViewModule() {
    }
    ListViewModule.decorators = [
        { type: _angular_core.NgModule, args: [{
                    imports: [
                        _angular_common.CommonModule,
                        _angular_forms.ReactiveFormsModule,
                        _angular_forms.FormsModule,
                        ngxBootstrap_dropdown.BsDropdownModule.forRoot()
                    ],
                    declarations: [
                        ClearFiltersComponent,
                        CounterComponent,
                        ListPreviewComponent,
                        ListRowComponent,
                        ListViewComponent,
                        NoResultsComponent,
                        NotFoundComponent,
                        PaginationComponent,
                        SearchComponent,
                        ShowMoreComponent,
                        ICheckDirective,
                        ListFilterComponent,
                        DateFilterComponent,
                        ListFormResetDirective
                    ],
                    exports: [
                        ClearFiltersComponent,
                        CounterComponent,
                        ListPreviewComponent,
                        ListRowComponent,
                        ListViewComponent,
                        NoResultsComponent,
                        NotFoundComponent,
                        PaginationComponent,
                        SearchComponent,
                        ShowMoreComponent,
                        ListFilterComponent,
                        DateFilterComponent,
                        ListFormResetDirective
                    ],
                    schemas: [_angular_core.CUSTOM_ELEMENTS_SCHEMA]
                },] },
    ];
    /** @nocollapse */
    ListViewModule.ctorParameters = function () { return []; };
    return ListViewModule;
}());

exports.ListViewModule = ListViewModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
