import { OnInit, EventEmitter, QueryList } from "@angular/core";
import { ICheckDirective } from "../../directives/icheck.directive";
export declare class ListFilterComponent implements OnInit {
    title: string;
    name: string;
    items: Array<any>;
    displayName: string;
    value: string;
    dataService: {
        getFilters: () => Array<any>;
        setParam: (name: string, filters: any) => any;
        fetchAll: (id?: any, payloadOnly?: boolean) => any;
    };
    checkedItems: any;
    filterEmitter: EventEmitter<any>;
    checkboxes: QueryList<ICheckDirective>;
    itemsActive: number;
    timeout: any;
    menuShown: boolean;
    ngOnInit(): void;
    reset(): void;
    /**
     * When a filter is made active or deactivated.
     *
     * @param name The name of the item.
     * @param event The filter returned.
     */
    rowChecked(name: string, event: Event): void;
    toggleClickMenu(e: Event): void;
    closeMenu(e: Event): void;
    showDropDown(): "block" | "hide";
}
