import { Component, ContentChildren, QueryList } from "@angular/core";
import { Input } from "@angular/core";
import { EventEmitter } from "@angular/core";
import { HostBinding } from "@angular/core";
import { ListFormResetDirective } from "../../directives/list-form-reset.directive";
var ListPreviewComponent = /** @class */ (function () {
    function ListPreviewComponent() {
        this.hidden = true;
        this.visibleEmitter = new EventEmitter();
        this.dataEmitter = new EventEmitter();
    }
    /**
     * Closes the list preview.
     */
    /**
         * Closes the list preview.
         */
    ListPreviewComponent.prototype.closePreview = /**
         * Closes the list preview.
         */
    function () {
        this.visibleEmitter.emit(true);
        this.hidden = true;
    };
    Object.defineProperty(ListPreviewComponent.prototype, "data", {
        /**
         * Gets the data.
         *
         * @returns {any}
         */
        get: /**
             * Gets the data.
             *
             * @returns {any}
             */
        function () {
            return this._data;
        },
        /**
         * Sets the data.
         *
         * @param data
         */
        set: /**
             * Sets the data.
             *
             * @param data
             */
        function (data) {
            this._data = data;
            this.forms.forEach(function (resetFormDir) {
                resetFormDir.form.resetForm(data);
            });
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Checks whether the user should be prompted to save changes if form is dirty.
     *
     * @returns {boolean}
     */
    /**
         * Checks whether the user should be prompted to save changes if form is dirty.
         *
         * @returns {boolean}
         */
    ListPreviewComponent.prototype.shouldPromptReset = /**
         * Checks whether the user should be prompted to save changes if form is dirty.
         *
         * @returns {boolean}
         */
    function () {
        var resets = this.forms.map(function (resetFormDir) {
            return resetFormDir.reset && resetFormDir.form.dirty;
        });
        return resets.indexOf(true) !== -1;
    };
    ListPreviewComponent.decorators = [
        { type: Component, args: [{
                    selector: "c-list-preview",
                    template: '<ng-content></ng-content> '
                },] },
    ];
    /** @nocollapse */
    ListPreviewComponent.ctorParameters = function () { return []; };
    ListPreviewComponent.propDecorators = {
        "hidden": [{ type: HostBinding, args: ["class.hidden",] },],
        "visibleEmitter": [{ type: Input },],
        "dataEmitter": [{ type: Input },],
        "forms": [{ type: ContentChildren, args: [ListFormResetDirective,] },],
    };
    return ListPreviewComponent;
}());
export { ListPreviewComponent };
//# sourceMappingURL=list.preview.component.js.map