import { Directive, OnChanges, ElementRef, Input, Output, EventEmitter, Renderer2, OnInit } from "@angular/core";
var ICheckDirective = /** @class */ (function () {
    function ICheckDirective(element, renderer) {
        this.element = element;
        this.renderer = renderer;
        this.icheckChange = new EventEmitter();
        this.type = "checkbox";
    }
    /**
     * @inheritDoc
     */
    /**
       * @inheritDoc
       */
    ICheckDirective.prototype.ngOnInit = /**
       * @inheritDoc
       */
    function () {
        var _this = this;
        this.parentElement = this.renderer.createElement('div');
        var currentParent = this.renderer.parentNode(this.element.nativeElement);
        this.renderer.insertBefore(currentParent, this.parentElement, this.element.nativeElement);
        this.renderer.addClass(this.parentElement, 'icheckbox_square-blue');
        this.renderer.setStyle(this.parentElement, 'position', 'relative');
        this.renderer.setStyle(this.element.nativeElement, 'display', 'none');
        this.renderer.listen(this.parentElement, 'click', function (event) { return _this.toggleCheckbox(event); });
    };
    /**
     * Toggles the checkbox.
     *
     * @param event
    */
    /**
       * Toggles the checkbox.
       *
       * @param event
      */
    ICheckDirective.prototype.toggleCheckbox = /**
       * Toggles the checkbox.
       *
       * @param event
      */
    function (event) {
        event.preventDefault();
        this.isChecked = !this.isChecked;
        this.updateCheckStatus();
    };
    /**
     * @inheritdoc
     */
    /**
       * @inheritdoc
       */
    ICheckDirective.prototype.ngOnChanges = /**
       * @inheritdoc
       */
    function (changes) {
        this.isChecked = this.isChecked || false;
        this.updateCheckStatus(false);
    };
    /**
     * Updates the value
     */
    /**
       * Updates the value
       */
    ICheckDirective.prototype.updateCheckStatus = /**
       * Updates the value
       */
    function (emit) {
        if (emit === void 0) { emit = true; }
        if (this.isChecked) {
            this.renderer.addClass(this.parentElement, 'checked');
        }
        else if (this.parentElement) {
            this.renderer.removeClass(this.parentElement, 'checked');
        }
        if (emit) {
            this.icheckChange.emit(+this.isChecked);
        }
    };
    ICheckDirective.prototype.check = function () {
        this.isChecked = true;
        this.updateCheckStatus();
    };
    ICheckDirective.prototype.unCheck = function () {
        this.isChecked = false;
        this.updateCheckStatus();
    };
    ICheckDirective.decorators = [
        { type: Directive, args: [{
                    selector: "input[icheck]"
                },] },
    ];
    /** @nocollapse */
    ICheckDirective.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: Renderer2, },
    ]; };
    ICheckDirective.propDecorators = {
        "isChecked": [{ type: Input, args: ["icheck",] },],
        "icheckChange": [{ type: Output },],
        "type": [{ type: Input },],
        "value": [{ type: Input },],
    };
    return ICheckDirective;
}());
export { ICheckDirective };
//# sourceMappingURL=icheck.directive.js.map